<!doctype html>
<html>

	<head>
		<meta charset="utf-8">
		<title>A Space BullShit</title>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/pixi.js/4.5.1/pixi.min.js"></script>
	</head>
	
	<body>
	
	<script>
	
			let Application = PIXI.Application, //pixi uygulamasının anasınıfı
					loader = PIXI.loader, // resimleri yüklemek için
					resources = PIXI.loader.resources, //resimleri yüklemek için
					Sprite = PIXI.Sprite, //yüklenen resimleri kullanmak için
					Container = PIXI.Container; // resimleri gruplandırmak için	
					
			
			let win = window,
    		doc = document,
    		docE = doc.documentElement,
    		docBody = docE.getElementsByTagName('body')[0],
    		docWidth = win.innerWidth || docE.clientWidth || docBody.clientWidth,
    		docHeight = win.innerHeight|| docE.clientHeight|| docBody.clientHeight;


			let app = new Application(
			{ 
    		width: docWidth, 
    		height: docHeight,                       
    		antialias: true, 
    		transparent: false, 
    		resolution: 1
  		});
  		
  		document.body.appendChild(app.view);
  		
  		loader
  			.add(["./assets/picture/black.png",
  						"./assets/picture/playerShip3_blue.png",
  						"./assets/picture/playerShip1_orange.png",
  						"./assets/picture/laserBlue02.png",
  						"./assets/picture/laserRed02.png",
  						"./assets/picture/beam0.png",
  						"./assets/picture/beam4.png",
  						"./assets/picture/cockpitBlue_1.png",
  						"./assets/picture/wingBlue_3.png",
  						"./assets/picture/wingRed_2.png",
  						"./assets/picture/cockpitRed_0.png",
  						"./assets/picture/teaport.png"])
  			.load(setup);//setup fonksiyonu içine yüklenir.
  			
  		let playerShip, kostokShip, playerLaser, kostokLaser, kostokLaser1, kostokLaser2,
  			intervalId, deathItem0, deathItem1, kostokDeathItem0, kostokDeathItem1,
  			playerDeathItem0, playerDeathItem1, teaPort;
  		
  		let kostokLaserList = [];
  		let kostokDeathSet = [];
  		let playerDeathSet = [];
  			
  		function setup()
  		{
  			let bg = new Sprite(resources["./assets/picture/black.png"].texture);
  				
  			bg.position.set(0, 0)
  			bg.width = docWidth;
  			bg.height = docHeight;
  			
  			bg.buttonMode = true;
  			bg.interactive = true;
  			
  			bg
  				.on('mousedown', touchStart)
          .on('mouseup', touchEnd)
          .on('mousemove', touchMove)
          .on('touchstart', touchStart)
          .on('touchmove', touchMove)
          .on('touchend', touchEnd); 
  				
  				
  			app.stage.addChild(bg);
  				
  			playerShip = new Sprite(resources["./assets/picture/playerShip3_blue.png"].texture);
  			
  			playerShip.width = docWidth / 20;
  			playerShip.height = docHeight / 10;
  			
  			playerShip.x = 60;
  			playerShip.y = docHeight / 2;
  			
  			playerShip.vx = 0;
  			playerShip.vy = 0;
  			
  			playerShip.state = "Live";
  			
  			playerShip.anchor.set(0.5);
  			playerShip.rotation = Math.PI / 2;
  				
  			app.stage.addChild(playerShip);

  			kostokShip = new Sprite(resources["./assets/picture/playerShip1_orange.png"].texture);
  			
  			kostokShip.anchor.set(0.5);
  			
  			kostokShip.width = docWidth / 20;
  			kostokShip.height = docHeight / 10;
  			
  			kostokShip.x = docWidth - 60;
  			kostokShip.y = docHeight / 2;
  			
  			kostokShip.vx = 0;
  			kostokShip.vy = 0;
  			
  			kostokShip.state = "Live";
  			
  			kostokShip.anchor.set(0.5);
  			kostokShip.rotation = 3 * (Math.PI/2);
  			
  			app.stage.addChild(kostokShip);

  			kostokLaser = new Sprite(resources["./assets/picture/laserRed02.png"].texture);
  			
  			kostokLaser.width = kostokShip.width / 4;
  			kostokLaser.height = kostokShip.height / 4;
  			
  			kostokLaserList.push(kostokLaser);

  			kostokLaser1 = new Sprite(resources["./assets/picture/laserRed02.png"].texture);
  			
  			kostokLaser1.width = kostokShip.width / 4;
  			kostokLaser1.height = kostokShip.height / 4;
  			
  			kostokLaserList.push(kostokLaser1);
  			
  			kostokLaser2 = new Sprite(resources["./assets/picture/laserRed02.png"].texture);
  			
  			kostokLaser2.width = kostokShip.width / 4;
  			kostokLaser2.height = kostokShip.height / 4;

  			kostokLaserList.push(kostokLaser2);
  			
  			playerLaser = new Sprite(resources["./assets/picture/laserBlue02.png"].texture);
  			
  			playerLaser.width = playerShip.width / 4;
  			playerLaser.height = playerShip.height / 4;
  			
  			kostokDeathItem0 = new Sprite(resources["./assets/picture/wingRed_2.png"].texture);
  			
  			kostokDeathItem0.width = kostokShip.width / 2;
  			kostokDeathItem0.height = kostokShip.height / 2;
  			
  			kostokDeathSet.push(kostokDeathItem0);
  			
  			kostokDeathItem1 = new Sprite(resources["./assets/picture/cockpitRed_0.png"].texture);
  			
  			kostokDeathItem1.width = kostokShip.width / 2;
  			kostokDeathItem1.height = kostokShip.height / 2;
  			
  			kostokDeathSet.push(kostokDeathItem1);
  			
  			teaPort = new Sprite(resources["./assets/picture/teaport.png"].texture);
  			
  			teaPort.width = kostokShip.width;
  			teaPort.height = kostokShip.height;
  			
  			kostokDeathSet.push(teaPort);
  			
  			deathItem0 = new Sprite(resources["./assets/picture/beam0.png"].texture);
  			
  			deathItem0.width = playerShip.width / 4;
  			deathItem0.height = playerShip.height / 4;
  			
  			kostokDeathSet.push(deathItem0);
  			playerDeathSet.push(deathItem0); 		
  			
  			deathItem1 = new Sprite(resources["./assets/picture/beam4.png"].texture);
  			
  			deathItem1.width = playerShip.width / 4;
  			deathItem1.height = playerShip.height / 4;
  			
  			kostokDeathSet.push(deathItem0);
  			playerDeathSet.push(deathItem0);
  			
  			playerDeathItem0 = new Sprite(resources["./assets/picture/cockpitBlue_1.png"].texture);
  			
  			playerDeathItem0.width = playerShip.width / 2;
  			playerDeathItem0.height = playerShip.height / 2;
  			
  			playerDeathSet.push(playerDeathItem0);
  			
  			playerDeathItem1 = new Sprite(resources["./assets/picture/wingRed_2.png"].texture);
  			
  			playerDeathItem1.width = playerShip.width / 4;
  			playerDeathItem1.height = playerShip.height / 2;
  			
  			playerDeathSet.push(playerDeathItem1);
  			
  			 		 			
  			let left = keyboard(37), //sol tuşun ascii kodu ile keyboar sınıfı örneklenir.
            up = keyboard(38),   //yukarı tuşun ascii kodu ile keyboar sınıfı örneklenir.
            right = keyboard(39),//sağ tuşun ascii kodu ile keyboar sınıfı örneklenir.
            down = keyboard(40),
            fire = keyboard(13); //alt tuşun ascii kodu ile keyboar sınıfı örneklenir.
            
			//sol tuşa basıldığında çalışacak method. 
        left.press = () => {
        
            //oyuncunun hızı atanır ve yön tayin edilir.
            //playerShip.rotation = 3*(Math.PI/2); // resim 270 derece döndürülür. bu sayede burnu sola bakar.
            playerShip.vx = -0.2;
            playerShip.vy = 0;
            
        };
  
        //sol tuş bırakıldığında çalışacak method.
        left.release = () => {
            //sol tuş bırakıldığında sağ tuşa basılı değil ise
            //gemi yatayda hareket etmez
            if (!right.isDown && playerShip.vy === 0) {
                playerShip.vx = 0;
            }
        };

        //üst
        up.press = () => {
        		
        		//playerShip.rotation = Math.PI * 0;
            playerShip.vy = -0.2;
            playerShip.vx = 0;
            
        };
        up.release = () => {
        
            if (!down.isDown && playerShip.vx === 0) {
                playerShip.vy = 0;
            }
        };

        //sağ
        right.press = () => {
        		
        		//playerShip.rotation = Math.PI / 2;
						playerShip.vx = 0.2;
            playerShip.vy = 0;
        };
        right.release = () => {
        
            if (!left.isDown && playerShip.vy === 0) {
                playerShip.vx = 0;
            }
        };

        //aşağı
        down.press = () => {
        
        		//playerShip.rotation = Math.PI;
            playerShip.vy = 0.2;
            playerShip.vx = 0;
            
        };
        down.release = () => {
        
            if (!up.isDown && playerShip.vx === 0) {
                playerShip.vy = 0;
            }
        };
        
        fire.press = () => {
        	if(contain(playerLaser, {x : 40, y : 20, width : docWidth, height : docHeight}) !== undefined &&
        		playerShip.state === "Live")
        	{
        		//playerShip.rotation = Math.PI / 2;
        		playerLaser.x = playerShip.x + playerShip.width / 2;
        		playerLaser.y = playerShip.y;
        		app.stage.addChild(playerLaser);
        	}
        
        
        }
        
        teleportKostok();
        
        app.ticker.add(delta => gameLoop(delta));
  			
  		}
  		
  		function gameLoop(delta)
  		{
  			
  			controlGameState();
  			
				if (contain(playerShip, {x : playerShip.width / 2, y : playerShip.height / 2, 
						width: docWidth, docHeight : 360}) === undefined)
				{
					playerShip.x += playerShip.vx; //oyuncu yatayda hareket ettikçe konumu değişir.
					playerShip.y += playerShip.vy; // oyuncu düşeyde hareket ettikçe konumu değişir.
				}
				
				if (contain(kostokShip, {x : kostokShip.width / 2, y : kostokShip.height / 2, 
						width: docWidth, height : docHeight}) !== undefined)
				{
 					kostokShip.x = docWidth - 60;
  				kostokShip.y = docHeight / 2;
				}
  			
  			kostokLaserList.forEach(function(laser){
  				if(contain(laser, {x : 0, y : 0, width: docWidth, height : docHeight}) !== undefined && 
  					kostokShip.state === "Live")
  				{
  					laser.x = kostokShip.x - kostokShip.width / 2;
  					laser.y = kostokShip.y
  				
  					app.stage.addChild(laser);
  				
  				}
  				if(kostokShip.state === "Death" || playerShip.state === "Death") app.stage.removeChild(laser);
  		
  			});
  			
  			
  			let number = randomInt(0, 10);
  			
  			if(number % 2 === 0)
  			{
  				kostokLaser.x -= 5;
  				kostokLaser.y += 0;
  			
  				kostokLaser1.x -= 5;
  				kostokLaser1.y += 0.5;
  			
  				kostokLaser2.x -= 5;
  				kostokLaser2.y -= 0.5;
  			}
  			
  			else if(number % 2 === 1)
  			{
  				kostokLaser.x -= 5;
  				kostokLaser.y += 0;
  			
  				kostokLaser1.x -= 4;
  				kostokLaser1.y += 0;
  			
  				kostokLaser2.x -= 3;
  				kostokLaser2.y += 0;  			
  			
  			
  			
  			}
  			
  			playerLaser.x += 1;
  			playerLaser.y += 0;
  			
  			if(playerLaser.x >= docWidth) app.stage.removeChild(playerLaser);
  			
  			if(kostokShip.state === "Live" && hitTestRectangle(playerLaser, kostokShip) && 
  				 kostokShip.visible === true)
  			{
  				deathOfShips(kostokShip, kostokDeathSet);
  				app.stage.removeChild(playerLaser);
  				
  			
  			}
  			
  			kostokLaserList.forEach(function(laser){
  				if(playerShip.state === "Live" && hitTestRectangle(laser,playerShip))
  				{
  					//deathOfShips(playerShip, playerDeathSet);
  				
  				}
  			
  			});
  			
  			if(hitTestRectangle(playerShip,teaPort))
  			{
  				app.stage.removeChild(teaPort);
  				let gameState = localStorage.getItem("levelState");
  				gameState = JSON.parse(gameState);
  				if(!gameState.userItemList.includes("teaport")) gameState.userItemList.push("teaport");
  				gameState.fightKostok = true;
  				localStorage.setItem("levelState", JSON.stringify(gameState));
  				
  			
  			}
  			
  			
  			
  		}
 		
 		function teleportKostok()
 		{
 			intervalId = setInterval(function(){
 			
 				let number = randomInt(0, 4);
 				
 				kostokShip.visible = false;
 				
 				if(number === 0) kostokShip.x -= 60;
 				else if(number === 1) kostokShip.y -= 60;
 				else if(number === 2) kostokShip.x += 60;
 				else if(number === 3) kostokShip.y += 60;
 				
 				setTimeout(function(){kostokShip.visible = true;}, 500);
 			}, 1000);
 			
 		}
 		
 		function deathOfShips(ship, itemList)
 		{
 			usedX = ship.x;
 			usedY = ship.y;
 			usedWidth = ship.width;
 			usedHeight = ship.height;
 			ship.state = "Death";
 			app.stage.removeChild(ship)
 			setTimeout(function(){
 				itemList.forEach(function(item){
 					item.x = randomInt(usedX, usedX + usedWidth);
 					item.y = randomInt(usedY, usedY + usedHeight);
 					app.stage.addChild(item);
 				
 				});
 			}, 100);
 		
 		
 		}
 		
 		function controlGameState()
 		{
 			if(kostokShip.state === "Death" || playerShip.state === "Death") clearInterval(intervalId);
 			if(playerShip.state === "Death")
 			{ 
 				setTimeout(function(){location.replace("../..//main.html");},1000);
 			
 			}
 			if(playerShip.state === "Live" && kostokShip.state === "Death")
 			{
 				setTimeout(function(){location.replace("../..//main.html");},5000);
 			}
 		
 		
 		}
 		
  	function randomInt(min, max)
  	{
  		return Math.floor(Math.random() * (max - min + 1)) + min;
		}
		 		
    function keyboard(keyCode)
     {
    
        let key = {};
        key.code = keyCode;
        key.isDown = false;
        key.isUp = true;
        key.press = undefined;
        key.release = undefined;
        //tuşa basıldığında tetiklecek olay
        key.downHandler = event => {
            if (event.keyCode === key.code) {
                if (key.isUp && key.press) key.press();
                key.isDown = true;
                key.isUp = false;
            }
        event.preventDefault();
    };

        //tuş bırakıldığında tetiklecek olay.
        key.upHandler = event => {
            if (event.keyCode === key.code) {
                if (key.isDown && key.release) key.release();
                key.isDown = false;
                key.isUp = true;
        }
        event.preventDefault();
    };

        //olay takip edici. klavye işlemlerini takip eder.
        //belirtilen fonksiyonu çağırır.(2. argüman)
        window.addEventListener(
            "keydown", key.downHandler.bind(key), false
        );
        window.addEventListener(
            "keyup", key.upHandler.bind(key), false
        );
        return key;
        
    }
    
    function contain(sprite, container)
     {

  		let collision = undefined;

  		//sol
  		if (sprite.x < container.x) {
    		sprite.x = container.x;
    		collision = "left";
  		}

  		//üst
  		if (sprite.y < container.y) {
    		sprite.y = container.y;
    		collision = "top";
  		}

  		//sağ
  		if (sprite.x + sprite.width / 2 > container.width) {
    		sprite.x = container.width - sprite.width;
    		collision = "right";
  		}

  		//alt
  		if (sprite.y + sprite.height / 2 > container.height) {
    		sprite.y = container.height - sprite.height;
    		collision = "bottom";
  		}

  		//Return the `collision` value
  		return collision;
		}
		
		function hitTestRectangle(r1, r2) {

  		
  		let hit, combinedHalfWidths, combinedHalfHeights, vx, vy;

  		
  		hit = false;

  		//çarpışma kontrolü yapılacak 2 nesnenin
  		//yatayda ve düşeyde orta noktaları bulunur.
  		r1.centerX = r1.x + r1.width / 2;
  		r1.centerY = r1.y + r1.height / 2;
  		r2.centerX = r2.x + r2.width / 2;
  		r2.centerY = r2.y + r2.height / 2;

  		
  		//yarı uzunlukları bulunur.
  		r1.halfWidth = r1.width / 2;
  		r1.halfHeight = r1.height / 2;
  		r2.halfWidth = r2.width / 2;
  		r2.halfHeight = r2.height / 2;

  		
  		//x ve y eksenleri arasındaki mesafe bulunur.
  		vx = r1.centerX - r2.centerX;
  		vy = r1.centerY - r2.centerY;

  		
  		//yarı uzunlukları toplamı bulunur.
  		combinedHalfWidths = r1.halfWidth + r2.halfWidth;
  		combinedHalfHeights = r1.halfHeight + r2.halfHeight;

  		//yatay merkezleri arasındaki mesafe
  		//yatay uzunlukları toplamının mutlak değerinden küçükse
  		if (Math.abs(vx) < combinedHalfWidths) {

    		//düşey merkezleri arasındaki mesafe
    		//düşey uzunluklarının toplamının mutlak değerinden küçükse
    		if (Math.abs(vy) < combinedHalfHeights) {

      		//çarpışma vardır.
      		hit = true;
    		} else {

      		//yoksa yoktur.
      		hit = false;
    		}
  		} else {

    	
    		hit = false;
  		}

  		return hit;
		};

		function touchStart(event){
			this.data = event.data;
			this.flag = true;
			this.startX = this.data.getLocalPosition(this.parent).x;
			this.startY = this.data.getLocalPosition(this.parent).y;
			
			if(this.startX < docWidth / 2 && 
				contain(playerLaser, {x : 40, y : 20, width : docWidth, height : docHeight}) !== undefined && 
				playerShip.state === "Live"){
      	        playerLaser.x = playerShip.x + playerShip.width / 2;
      	        playerLaser.y = playerShip.y;
      	        app.stage.addChild(playerLaser);			
			
			}
		}
		
		function touchEnd(){
			this.flag = false;
			this.data = null;
			playerShip.vx = 0;
			playerShip.vy = 0;
		}
		
		function touchMove(event){
			if(event.target !== null && this.flag && this.startX >= docWidth / 2)
			{
				console.log("in");
				this.curX = this.data.getLocalPosition(this.parent).x;
				this.curY = this.data.getLocalPosition(this.parent).y;
				if (this.curX - this.startX > 0 && Math.abs(this.curX-this.startX)>Math.abs(this.curY-this.startY)) {
					playerShip.vx = 0.2;
					playerShip.vy = 0;
					console.log(playerShip.vx);
					console.log(playerShip.vy);
				}
				if(this.curX - this.startX < 0 && Math.abs(this.curX-this.startX)>Math.abs(this.curY-this.startY)){
					playerShip.vx = -0.2;
					playerShip.vy = 0;
					console.log(playerShip.vx);
					console.log(playerShip.vy);					
				}
				if(this.curY - this.startY > 0 && Math.abs(this.curX-this.startX)<Math.abs(this.curY-this.startY)){
					playerShip.vx = 0;
					playerShip.vy = 0.2;
					console.log(playerShip.vx);
					console.log(playerShip.vy);							
				}
				if(this.curY - this.startY < 0 && Math.abs(this.curX-this.startX)<Math.abs(this.curY-this.startY)){
					playerShip.vx = 0;
					playerShip.vy = -0.2;
					console.log(playerShip.vx);
					console.log(playerShip.vy);							
				}
			}
		}
 			
	
	</script>
	
	</body>
</html>
